function G_debugging_practice2019_071119(stereo)
% DEBUGGING_PRACTICE This should be a one-line description of the function.
%
%   These few lines should be used to describe the function in more detail.
%   They will be shown if the user types "help G_debugging_practice2019".
%   E.g.
%   G_debugging_practice2019([stereo]) is an error-ridden function, for 
%   practicing debugging. If all the errors are fixed then it should 
%   display a random dot stereogram of a sphere revolving within a cylinder.
%   For more precise timing and sophisticated animation, Psychtoolbox could
%   be used.
%   
%   Inputs:
%    - stero: a boolean flag indicating whether or not to present in stereo
%             (default: true)
%
%   See also    SOMEOTHERSILLYFUNCTION.

%   Any comments after the first blank line are not shown in the help.
%   These first few lines are often used to give details of version & author.
%   E.g.
%   Created by djm 
%   $Revision: 1.0 $  $Date: 01/11/2019 $

% This is an example of a single-line comment

%{
This is an example of...
...a multi-line comment!
%}

%% This is an example of a cell
% It's a chunk of the code that you might want to highlight or execute as a
% unit. This one is empty! It might not be identified until any parsing errors are corrected.

%% The main code starts here...

% Prepare to catch the errors!
dbstop if error

%% define constants
if ~nargin, stereo=true; end

cylinder.npoints=4; % number of points, e.g. 300 % THERE MIGHT BE A PROBLEM HERE!
sphere.npoints=ceil(cylinder.npoints/2);
sphere.radius=1; % arbitrary units
cylinder.radius=1.5;
origin=[0 0 0];
disparity=0.09; % radians

%% create some random points on the surface of a sphere
sphere.theta=randn(1,sphere.npoints)*0.15*pi +pi/2; % radians (from normal distribution with clustering at equator)
sphere.phi=rand(1,sphere.npoints)*2*pi; % radians (from uniform distribution)
sphere.z=origin{3}+sphere.radius*cos(sphere.theta); % THERE MIGHT BE A PROBLEM HERE!

%% create some random points on the surface of a cyclinder
cylinder.theta=rand(1,cylinder_npoints)*2*pi; % THERE MIGHT BE A PROBLEM HERE!
cylinder.z=rand(1,cylinder.npoints)*3*sphere.radius-3*sphere.radius/2;

%% define rotation speed of each point
sphere.speed=randn(1,sphere.npoints)*0+0.5; % radians per second
cylinder.speed=randn(cylinder.npoints)*0+0.5; % THERE MIGHT BE A PROBLEM HERE!

%% prepare figure, axes, and points
% (twice as many points if stereo==1)
figure(10); clf(10); set(10,'color','w')
ax=subplot('position',[1 1 1 1]); % Create axes to fill the window. THERE MIGHT BE A PROBLEM HERE!
sphere.handle=scatter3(ax,...
    zeros(1,sphere.npoints*(stereo+1)),...
    zeros(1,sphere.npoints*(stereo+1)),...
    repmat(sphere.z,1,stereo+1),[],'k','filled');
hold on
cylinder.handle=scatter3(ax,...
    zeros(1,cylinder.npoints*(stereo+1)),...
    zeros(1,cylinder.npoints*(stereo+1)),...
    repmat(cylinder.z,1,stereo),[],'k','solid'); % THERE MIGHT BE TWO PROBLEMS HERE!

axis image off
view(0,0)
xlim(max(sphere.radius,cylinder.radius) * [-1 3]);
ylim(max(sphere.radius,cylinder.radius) * [-1 1]);
zlim(sphere.radius * [-1.5 1.5]);

%% run the animation 
time=tic; % start a timer

% this should loop until the figure is closed
while ishandle(ax) % THERE MIGHT BE A PROBLEM HERE! (OR IS IT CAUSED BY SOMETHING BELOW?)
    
    % check how far the objects should have rotated since the last display...
    sphere.phi=sphere.phi+sphere.speed*toc(time);
    cylinder.theta=cylinder.theta-cylinder.speed*toc(time); % THERE MIGHT BE A PROBLEM HERE! (OR IS IT CAUSED BY SOMETHING ABOVE?)
    time=tic; %....then reset the timer 
    
    % work out the new x and y coordinates
    sphere.x=origin(1)+sphere.radius*sin(sphere.theta).*cos(sphere.phi);
    sphere.y=origin(2)+sphere.radius*sin(sphere.theta)*sin(sphere.phi);  % THERE MIGHT BE A PROBLEM HERE!
    
    cylinder.x=origin(1)+sin(cylinder.theta)*cylinder.radius;
    cylinder.y=origin(3)+cos(cylinder.theta)*cylinder.radius;
         
    if stereo=1 % THERE MIGHT BE A PROBLEM HERE!
        
        % make new sets of x codinates for rotated objects 
        sphere.x2=3*sphere.radius+origin(1)+sphere.radius*sin(sphere.theta).*cos(sphere.phi-disparity);
        cylinder.x2=3*sphere.radius+origin(1)+sin(cylinder.theta-disparity)*cylinder.radius;
        
        % update the handle of the point clouds with duplicated cyclinder and sphere    
        %sphere.handle.XData=[sphere.x sphere.x2]; % this syntax works in Matlab 2014b and later
        set(sphere.handle,'XData',[sphere.x sphere.x2]);
        set(cylinder.handle,'XData',[cylinder.x cylinder.x2]); % THERE MIGHT BE A PROBLEM HERE! (OR IS IT SOMETHING ABOVE?)
        
         % could update y coordinates, but don't need to
%         set(sphere.handle,'YData',[sphere.y sphere.y]);
%         set(cylinder.handle,'YData',[cylinder.y cylinder.y]);
        
    else % update the handle of the point clouds with single cyclinder and sphere       

        set(sphere.handle,'XData',sphere.x);
        set(cylinder.handle,'XData',cylinder.x);
        
%         set(sphere.handle,'YData',sphere.y);
%         set(cylinder.handle,'YData',cylinder.y);
        
    end
    
    % set the colour of the points based on perceived depth
    if ~verLessThan('matlab', '8.5.0') % v slow prior to version 2014b
        set(cylinder.handle,'CData',cylinder.y-min(cylinder.y));
        set(cylinder.handle,'CData',repmat(get(cylinder.handle,'CData')/max(get(cylinder.handle','CData'))/2+0.25,3,stereo+1)');
        
        set(sphere.handle,'ColourData',sphere.y-min(sphere.y)); % THERE MIGHT BE A PROBLEM HERE!
        set(sphere.handle,'CData',repmat(0.75-get(sphere.handle,'CData')/max(get(sphere.handle,'CData'))/2,3,stereo+1)');
    end
     
    % choose some points to hide...
    cylinder.toshow=cylinder.y<0 | ...
        ((cylinder.x-origin(1)).^2 + (cylinder.z-origin(3)).^2) > sphere.radius; % the bit of the cyclinder behind the sphere
    sphere.toshow=(sphere.y>0); % the back of the sphere
    % ...and hide them
    cylinder=hidepoints(cylinder,stereo); % THERE MIGHT BE A PROBLEM HERE! (OR IS IT SOMETHING BELOW?)
    sphere=hidepoints(sphere); % THERE MIGHT BE A PROBLEM HERE!
    
    % create title for figure
    if ~exist('tit','var') 
        switch stereo
            case true
                tit=title(sprintf('Well done! Fuse stero pair with cross-eye method\n\n'));
            otherwise
                tit=title('Well done!');
        end
    end
    drawnow

    % clear the axis handle
    clear ax % THERE MIGHT BE A PROBLEM HERE!
    
end % each iteration of loop % THERE MIGHT BE A PROBLEM HERE! (OR IS IT CAUSED BY SOMETHING ABOVE?)

return

function hidepoints(obj,stereo) % THERE MIGHT BE A PROBLEM HERE!

% this line would work in version 2014b and later
% obj.handle.CData(~repmat(obj.toshow,1,stereo+1),:)=nan; % THERE MIGHT BE A PROBLEM HERE! (OR IS IT ABOVE?)

temp=get(obj.handle,'XData');
temp(~repmat(obj.toshow,1,stereo+1))=nan; % THERE MIGHT BE A PROBLEM HERE! (OR IS IT ABOVE?)
set(obj.handle,'XData',temp);

return
